param T;

set TIMESTEPS ordered :=0..T;
set ASSETS;

param asset_developpment{TIMESTEPS,ASSETS};
param initial_assets{ASSETS};
param inflow{TIMESTEPS};

var owned{TIMESTEPS,ASSETS} >=0;
var buy{TIMESTEPS,ASSETS} >=0;
var sell{TIMESTEPS,ASSETS} >=0;

maximize end_wealth:
     sum{ a in ASSETS} owned[last(TIMESTEPS),a];

subject to mass_conservation{t in TIMESTEPS}:
     sum{ a in ASSETS}(buy[t,a]-sell[t,a])=inflow[t];

subject to developpment{t in TIMESTEPS, a in ASSETS}:
     owned[t,a]=
     	  asset_developpment[t,a]*(if t!=first(TIMESTEPS) then owned[prev(t),a] else initial_assets[a] )
     	  +buy[t,a]-sell[t,a];


