param levels;
param split;
param last_node:=sum{i in 1..levels-1} split^i;
set NODES ordered := 0..last_node;

param parent{n in NODES} := if n=0 then -1 else (n-1) div split;
param child_no{n in NODES} := if n=0 then -1 else (n-1) mod split;

param level{n in NODES}:=if parent[n]==-1 then 0 else 1+level[parent[n]];

set LEAFS within NODES := setof{ n in NODES : level[n]=max{i in NODES} level[i]} n;
set ROOT within NODES := setof{ n in NODES : parent[n]==-1} n;


param pre_prob{0..split-1};
param prob{ n in NODES} := if n == 0 then 1 else prob[parent[n]]*pre_prob[child_no[n]];

set ASSETS;

param asset_developpment{ASSETS,0..split-1};
param initial_assets{ASSETS};
param inflow{0..split-1};
param inflow_root;

var owned{ASSETS,NODES} >=0;
var buy{ASSETS,NODES} >=0;
var sell{ASSETS, NODES} >=0;

maximize end_wealth:
     sum{ a in ASSETS, n in LEAFS} prob[n]*owned[a,n];

subject to mass_conservation{n in NODES diff ROOT}:
     sum{ a in ASSETS}(buy[a,n]-sell[a,n])=inflow[child_no[n]];

subject to mass_conservation_root{n in ROOT}:
     sum{ a in ASSETS}(buy[a,n]-sell[a,n])=inflow_root;

subject to developpment{n in NODES diff ROOT, a in ASSETS}:
     owned[a,n]=
     	  asset_developpment[a,child_no[n]]*owned[a,parent[n]]
     	  +buy[a,n]-sell[a,n];

subject to initial_owned{a in ASSETS, n in ROOT}:
     owned[a,n]=initial_assets[a]+buy[a,n]-sell[a,n];
