set INGREDIENS;
set PRODUKT;
set SUBSTANS;

param andel{INGREDIENS,SUBSTANS} >=0;
param undre_grns{PRODUKT,SUBSTANS} >=0;
param vre_grns{PRODUKT,SUBSTANS} >=0;
param kostnad{INGREDIENS};
param max_total{INGREDIENS};
param nskad_mngd{PRODUKT};

var x{INGREDIENS,PRODUKT}>=0;


minimize total_kostnad: 
     sum{i in INGREDIENS, p in PRODUKT}x[i,p]*kostnad[i];

subject to efterfrgan {p in PRODUKT}:
     sum{ i in INGREDIENS} x[i,p] = nskad_mngd[p];

subject to undre_andel{s in SUBSTANS, p in PRODUKT}:
     sum{ i in INGREDIENS} x[i,p]*andel[i,p] >=
     undre_grns[p,s]*nskad_mngd[p];

subject to vre_andel{s in SUBSTANS, p in PRODUKT}:
     sum{ i in INGREDIENS} x[i,p]*andel[i,p] <=
     vre_grns[p,s]*nskad_mngd[p];

subject to max_lager{i in INGREDIENS}:
     sum{p in PRODUKT} x[i,p] <= max_total[i];
